
#define VERSION "190427"
// Rajout capteur OWS DS18B20
//  Test Sonde OWS DS18B20
// Family Code : 28 ID1= AA0D82381401  CRC= CD
 
// fonte 8x8 modifi en 6x8  pour les chiffres
//#define VERSION "190425"

//#define VERSION "190424"
// rajout MAJ RTC ..OK    dialogue UART OK
// rajout Anneau 60 leds en SPI
// Mode Pre_TESTS avec entree RA2

//#define VERSION "190422"
// 4 matrices pour afficher HH:MM pilotees en SPI   bit bang
// RTC DS3231 en I2C1 hardware

#define DIRECTORY  "C:\_MikroC\_MesProjets_MikroC\C:\Horloge_Anneau_60leds"
#define PROJECT "Horloge_4_Matrice8x8_Anneau_60leds_RGB.mcppi"
#define SOURCE "Horloge_4_Matrice8x8_Anneau_60leds_RGB_"
#define CONFIG "PIC18F26k22_FOSC_interne_16x4-64MHZ.cfgsch"
#define OTHERS  "Tiny_RTC_DS3231_for_AI2_1904.c"
#define EEPROM  "18F26K22_....ihex"


#define PROCESSOR "18F26K22"
#define POWER_SUPPLY "3.6V_mini"

#define FOSC_INTERNE
#define FOSC 16.0
#define BAUD 19200  // UART1
#define Langage  Mikroc V 7.30
#define With_UART1
#define DEBUGGING




//HARDWARE module
// Circuit imprim : Base 18F26K22
// UART RC6 =TX=fil blanc   RC7= RX=fil vert  Interface Prolific LTTL/USB  -> COM12 19200  -> PC XP  VBray 2014
// librairies utilises:
// UART , C_String   C_Stdlib   Conversions , I2C1  , OWS
// EEPROM :

/* Config bit  :
 PIC18F26k22_FOSC_interne_16x4-64MHZ.cfgsch
CONFIG1H : $300001 : 0x0038
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BF
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040

*/


// 

//  ac:SPI_link

 /*
 HARDWARE :
ATTENTION connections HORIZONTALE avec NEW Matrices MAX7219 CMS
 ref matrice 8x8 sur le bas de l'afficheur
 led #1  entre PIN9 et Pin 13 , en haut  gauche  = Digit0 col 0
// ------------------------------- RTC  DS3231------
RB0 pin ..  --<--------------------  blanc --- 5 SQW 1Hz
RC3  Pin .. -->----- I2C1  SCL1  --  vert ---- 4 SCL
RC4  Pin .. --<>----- I2C1  SDA1 --  jaune --- 3 SDA
=5v -------------------------------- orange ---2 VCC
0V Gnd ----------------------------- marron ---1 GND

+5V    ---------------------------------- Pin 1  MAX7219x4 #1  -  MAX7219x4 #2- -- MAX7219x4 #3 -- MAX7219x4 #4
0V Gnd  --------------------------------- Pin 2  MAX7219x4 #1  -  MAX7219x4 #2- -- MAX7219x4 #3 -- MAX7219x4 #4
 RC1   pin .. SPI1      SDO       ------- Pin 3  MAX7219x4 #1  -  MAX7219x4 #2- -- MAX7219x4 #3 -- MAX7219x4 #4
RC0   pin ..  Select    CS        ------- Pin 4  MAX7219x4 #1  -  MAX7219x4 #2- -- MAX7219x4 #3 -- MAX7219x4 #4
RC2   pin ..  SPI1      CLCK      ------- Pin 5  MAX7219x4 #1  -  MAX7219x4 #2- -- MAX7219x4 #3 -- MAX7219x4 #4

UART1 TX  sur RC6        pin ..  --- blanc  RX cordon Prolix
UART1 RX  sur RC7        pin ..  --- vert  TX cordon Prolix
Gnd 0V  ---------------------------- noir  Gnd Cordon Prolix
                              N.C. --rouge +5V USB

// module BlueTooth Linvor (VERT ) @=20:13:01:24:11:22
// JY-MCU   Power 3,3  6V
//                                          Pin 6   STATE
//UART1 .. 25  RC6 --- R=750---fil vert --> Pin 5   TXD  3,3V
//UART1 .. 26  RC7 ------------fil blanc<---Pin 4   RXD
//                   0V Gnd ----fil noir---- Pin 3   GND
//                   +5V -------fil rouge ---Pin 2   VCC
//                                           Pin 1  KEY

+VCC ----|-----------------------------
         |--- pull up ----R=2,7K --|
RA0 Pin 02  ----<------------------|---  bus OWS  pour DS18B20 sensor
0V ------------------------------------

+VCC ----------------------R=2,7K ----Pin1 LM3335   Alim
RA1 Pin 03   ----<--- Entree Analog 1 Pin2 du LM335  Output
0V -------------------R 100K -------- Pin 3 du LM335 adjust
*/
#include "built_in.h"     // for  Hi  Lo ..etc

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space
#define Byte unsigned char
#define Word unsigned int

#define OWS_Pin_Sensor1  &PORTA,0     // sensor DS18B20 #1 OWS

#define RTC_DS3231
#define DS3231_ADDR 0xD0 // RTC DS3231 + 24C32
 // I2C SDA sur RC4
 // I2C SCL sur RC3

sbit RTC_Forcee          at PORTB.B1;
sbit RTC_Forcee_Dir      at TRISB.B1 ;
sbit HZ                  at LATC.B5;
sbit HZ_Dir              at TRISC.B5;
sbit Alarme_Melodie      at LATB.B2;
sbit Alarme_Melodie_Dir  at LATB.B2;
sbit Clignote_Sec        at LATA.B5;
sbit Clignote_Sec_Dir    at TRISA.B5;
 

 // pin 1 circuit M948A-2  Melodie
#define STOP 0         //   Bit RB7=0  --> ULN   ---> 1  stop melodie
#define RING 128       //   Bit RB7=1  --> ULN -> 0  active melodie

#define NB_LEDS 60
#define NbCycles_T1 8       // nb d'interrupot pour faire 1 seconde

sbit Led_Rouge      at LATA4_bit;
sbit Led_Rouge_Dir  at TRISA4_bit;
sbit SQA           at PORTA.B3;
sbit SQA_Dir       at TRISA3_bit;
sbit Pre_TESTS     at PORTA.B2;
sbit Pre_TESTS_Dir at TRISA2_bit;

//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  (9 default setting; can be 9,10,11,or 12)
//  18B20: 12
const unsigned short TEMP_RESOLUTION = 12;
long  DS18B20_Temp1=0L;
int temp_fraction;
char temp_whole,Signe;
unsigned  int tempL=0;
unsigned   int temp=0;
unsigned char ID1[7];

// SPI bit BANG pour Matrices MAX7219
sbit SPI_CS        at LATC0_bit;
sbit SPI_CS_Dir    at TRISC0_bit;
sbit SPI_CLOCK     at LATC2_bit;
sbit SPI_CLOCK_Dir at TRISC2_bit;
sbit SPI_DOUT      at LATC1_bit;
sbit SPI_DOUT_Dir  at TRISC1_bit;
// cde Anneau 60 leds
sbit DOut          at LATC.B5;               //DATA  OUT PIN
sbit DOut_Dir      at TRISC.B5;   //DATA DIRECTION Output

const code char mesg0[]=" Mikroc 7.3.0 "PROCESSOR" \r\n";
const code char mesg1[]=" Directory : "DIRECTORY" \r\n";
const code char mesg2[]=" Projet : "PROJECT"\r\n";
const code char mesg3[]=" Source : "SOURCE"_"VERSION".c \r\n";
const code char mesg4[]=" 1 Modules New 4 Matrices 8x8 avec MAX7129 CMS\r\n";
const code char mesg5[]=" Terminal pourdailogue et Visu  deroulement programme\r\n";
const code char mesg6[]= " Alim ="POWER_SUPPLY"\r\n";
const code char mesg7[]=" SPI WS2812 bit bang pour Anneau et SPI bit bang pour MAX7219\r\n";
const code char mesg8[]=" Autres : "OTHERS"\r\n";
const code char mesg9[]=" Messages en EEPROM avec cde : <EEPROM=0> ..  15 \r\n";

const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};
const char Blancs[]="  ";

const code char Jour0[]="Dimanche";
const code char Jour1[]="Lundi";
const code char Jour2[]="Mardi";
const code char Jour3[]="Mercredi.";
const code char Jour4[]="Jeudi";
const code char Jour5[]="Vendredi";
const code char Jour6[]="Samedi";
const code char * JourSemaine[]={Jour0,Jour1,Jour2,Jour3,Jour4,Jour5,Jour6};

unsigned char LATCx absolute 0x0F8B;

#define MAXLEN2 128
#define MAXLEN_BUFFER1 128
unsigned char Buffer1[MAXLEN_BUFFER1];
volatile unsigned int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile unsigned int Index1;
volatile unsigned int CptErr;

volatile char Temperat[30];
volatile unsigned char TP_Deg,TP_Deci;
volatile unsigned int TAmb;

unsigned char Rouge,Vert,Bleu,Mode;

unsigned char Melodie=STOP;
unsigned int Duree_Melodie=5; // 5 Sec par defaut
signed  char Offset_Temper;
signed char Dummy;
// gamme Horaire de validation Melodie
unsigned int MinHour=8;  // 8H  21H00
unsigned int MaxHour=21;

int Status;
unsigned char Adr;
char time[]="00:00:00";
char date[]="00/00/00";
volatile unsigned char Sec,Mn,Hour;
unsigned char OldSec;

unsigned int  val1;
unsigned long val2;
unsigned long val3;

unsigned short second,minute,heure,jS,jour,mois,Annee;
unsigned short DateTime[9];
//volatile int Flag_Timer2=0;

volatile int Flag_Timer1;
volatile unsigned int Cpt1;
volatile unsigned int Max_Timer1;

volatile unsigned int Flag_RB0;

// 12 MAX7129 matrice 8x8
static unsigned char Aff_buffer[96];  //  12*8*8 + eventuell string terminator=0
static  unsigned char Aff_buffer2[96];

static unsigned char Lettre_A[8]={
                 0b00011000,
                 0b00111100,
                 0b01100110,
                 0b01100110,
                 0b01111110,
                 0b01100110,
                 0b01100110,
                 0b01100110};
                 
 // separateur HH et MM
static unsigned char Lettre_Sep[8]={
         0x00, 0x00, 0x02, 0x02, 0x00, 0x02, 0x02, 0x00,        // Char 221 (.)
       };
static unsigned char Lettre_Point[8]={
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02,        // Char 251 (.)
       };
static unsigned char Lettre_Degre_C[8]={
         0xE0, 0xA0, 0xEF, 0x08, 0x08, 0x08, 0x08, 0x0F,        // Char 127 (.)
  };
  
Byte Rotate_90[8];

 unsigned int cx;
 unsigned int mx;

signed int j1;

unsigned int i,j,k,l,m,n;
unsigned  char TEXTE[MAXLEN2]; // pour teste quelconque
unsigned char TEXTE2[MAXLEN2]; // pour temperature Amb
unsigned char * txt;
unsigned char * txt2;
unsigned char *p1;
unsigned char *p2;
volatile unsigned char CRam1[80];   // for flot2asccii use
volatile int js;
int ms;

int nM;
unsigned char N1;
unsigned char  addr,donnee;
unsigned int Etat;
unsigned int clk;
unsigned long OverFlow_Timer0;
unsigned long L1,L2;
unsigned char Cpt=0;

unsigned int Pas;
unsigned int Count0;
unsigned int  Flag_Timer0=0;

float f1,f2,ff;

unsigned int Speed=100;

volatile struct chbits {   // 8 flags
     unsigned FrameErr:1;
     unsigned Over:1;
     unsigned RTC_Initialise: 1;
     unsigned FLT:1;
     unsigned PPS:1;
     unsigned Temper:1;
     unsigned Elapsed_Time:1;
     unsigned Mesure:1;
     unsigned First_Run:1;
   }Drapeaux ;

unsigned char Poids[8]={128,64,32,16,8,4,2,1};

unsigned long L0;
long *p32;
static Byte Bx[13];
unsigned char *pB;

static union {
        long Lx;
        Byte Bn[4];
          };

//#include "../common/fonte_8x8_V.h"   //     0x00, 0x84, 0x82, 0x81, 0xFF, 0x80, 0x80, 0x00,        // Char 049 (1)
//#include "../common/font_8x8_H.h"        //     0x10, 0x70, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7C,        // Char 049 (1)
//#include "My_8X8_FONT_190422.h"
//#include "THIN_SS.h"
//#include "VGA-ROM.h"
#include "CP112_degre.h"


#define REG_DECODE        0x09                        // "decode mode" register
#define REG_INTENSITY     0x0A                        // "intensity" register
#define REG_SCAN_LIMIT    0x0B                        // "scan limit" register
#define REG_SHUTDOWN      0x0C                        // "shutdown" register
#define REG_DISPLAY_TEST  0x0F                        // "display test" register
#define INTENSITY_MIN     0x00                        // minimum display intensity  1/32
#define INTENSITY_MAX     0x0F                        // maximum display intensity  31/32
#define INTENSITY_MOY     0x07                        // moyenne 15/32

#include "Tiny_RTC_DS3231_for_AI2_1904.h"

// -----------------------------------------------------------

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;

void strConstRamCpy(unsigned char *dest, const code char *source);
void UART1_Write_CText(const char *txt);
void RAZ_UART1(void);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF1(void)  ;




void MAJ_RTC(void);
void  RAZ_Anneau_60_Leds(void);
void Init_Timer3(void);
void DS18B20_Build_value(unsigned int temp2write);

//#include "Matrices_4x_8x8.h"

void Init_4_Module_Max7219_8x8(void);
void Affiche_CText_Matrice(const Byte *p2, unsigned int V2);
void SPI_Write_To_4x7219(Byte adr, Byte d1, Byte d2,Byte d3, Byte d4) ;
void SPI_Write_To_7219(Byte adr, Byte d1) ;
void SPI_WRITE_Byte(Byte x) ;
void Affiche_Text_Matrice(Byte *p1, Byte Type) ;
void ecr_7219_def(Byte ad1, Byte dat1, Byte dat2 ) ;
void Efface_Aff(void);
void Clear_4_Matrice(void) ;



 void Interrupts() iv 0x0008 ics ICS_AUTO
 {
 if ( (RC1IE_bit==1) && ( RC1IF_bit==1))
   {
   //TXREG1='$';
   // traitement separe des erreurs de COM
    // c1 = UART1_Read();
     c1=RCREG1;
      if (RCSTA1.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA1.CREN = 0 ;
       c1 = RCREG1;
       RCSTA1.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA1.FERR==1 )
      {
      RCSTA1.SPEN = 0 ;
      RCSTA1.SPEN= 1 ;
      CptErr++;
       c1 = RCREG1;
      }
     if ((c1==CR) || (i1 > MAXLEN_BUFFER1-2))
      {
      Flag_Buffer1=1;
      if (i1 > MAXLEN_BUFFER1-2)  Flag_Buffer1=2;
      PIE1.RC1IE=0 ; //interdit IT Reception UART
      Buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {

        Buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
   // -----  timer 1  ----------------
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1--;

     if (Cpt1 <1)   // x100 ms  @16MHz
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Flag_Timer1=1;
      }
     TMR1H         = 0x3C;
     TMR1L         = 0xB0;
     TMR1IF_bit=0;
   }
   // RB0 interrupt
    if ((INT0IE_bit) && (INT0IF_bit))
    {

    // TXREG1='@';  // pour debugging sur UART1
      Flag_RB0=1 ;
      INT0IF_bit=0;
     // INT0IE_bit=0;    // bloque les IT suivantes
   }
 }
 
 

void Init_4_Module_Max7219_8x8(void)     // 4 matrices
 {   int i;
   SPI_Write_To_4x7219(REG_DISPLAY_TEST, 0x00,0x00,0x00,0x00); // pas de test - no test
   SPI_Write_To_4x7219(REG_DECODE,       0x00,0x00,0x00,0x00); //pas de decodage - no decode
   SPI_Write_To_4x7219(REG_INTENSITY,    0x01,0x01,0x01,0x01); //intensité - intensity  minima
   //intensité - intensity  minima
  //scan limit registre  digit 0 à 7 ..
  SPI_Write_To_4x7219(REG_SCAN_LIMIT ,   0x07,0x07,0x07,0x07);
  SPI_Write_To_4x7219(REG_SHUTDOWN,      0x01,0x01,0x01,0x01); // normal operation
  Delay_ms(2);
  for (i=0;i<8;i++) SPI_Write_To_4x7219(0, 0x00,0x00,0x00,0x00);
  Clear_4_Matrice() ;
 Delay_ms(10);
 }


void SPI_Write_To_4x7219(Byte adr, Byte d1, Byte d2,Byte d3, Byte d4)
  {  SPI_CS = 0;
    Delay_us(15);
     SPI_WRITE_Byte(adr);    SPI_WRITE_Byte(d1);
    SPI_WRITE_Byte(adr);    SPI_WRITE_Byte(d2);
    SPI_WRITE_Byte(adr);    SPI_WRITE_Byte(d3);
    SPI_WRITE_Byte(adr);    SPI_WRITE_Byte(d4);

   Delay_us(10);
    SPI_CS = 1;
}


 void SPI_Write_To_7219(Byte adr, Byte d1)
  {
  SPI_CS = 0;
  Delay_us(15);
  SPI_WRITE_Byte(adr);
  SPI_WRITE_Byte(d1);
  Delay_us(10);
   SPI_CS = 1;
}



void SPI_WRITE_Byte(Byte x)
 {
 int i;
 Byte c;
 c=x;
 SPI_DOUT=0;
 for (i=0;i<8;i++)
 {
  if ((c & 0x80)==0x80)
   SPI_DOUT=1;
   else
   SPI_DOUT=0;
  Delay_us(8);
  c=c<<1;
  SPI_CLOCK=1;
  Delay_us(8);
  SPI_CLOCK=0;
   Delay_us(8);
  }
 }



void Affiche_Text_Matrice(Byte *p1, Byte Type)
{
Byte c1;
int i,j,k,n;
 //  for (i=0;i<96;i++)
 //  {
  //   Aff_buffer[i]=0;
  //  }
    k=0;
    n=0;
    j=0;
     while (*(p1)>0)
     {
        c1=*(p1);
        k=(c1*8);
        for (i=0;i<8;i++)
        {
         Aff_buffer[j+i]= font_8x8_H[k+i];
           // sens Gauche   --> droite
       if(Type==0)
        {  // affiche TIME
           if ((n==1)&& (Sec %2==0))  Aff_buffer[8+i]= Aff_buffer[8+i]  |  Lettre_Sep[i];
           SPI_Write_To_4x7219(i+1,Aff_buffer[24+i],Aff_buffer[16+i],Aff_buffer[8+i],Aff_buffer[i]);
           }
           else
            {
            // affiche temperature
            if (n==1) Aff_buffer[8+i]= Aff_buffer[8+i]  |  Lettre_Point[i];   // point decimal temperature
            SPI_Write_To_4x7219(i+1,Aff_buffer[24+i],Aff_buffer[16+i],Aff_buffer[8+i],Aff_buffer[i]);
            }
      }
       j=j+8;
       p1++;
       n++;
     }
   }


 void ecr_7219_def(Byte ad1, Byte dat1, Byte dat2 )
 {
     SPI_CS = 0 ;
     SPI_WRITE_Byte(ad1);
     SPI_WRITE_Byte(dat1);
     SPI_WRITE_Byte(ad1);
     SPI_WRITE_Byte(dat2);
     SPI_CS = 1;
     }


 void Efface_Aff()
  {
       int i;
       for ( i=0;i<48;i++) ecr_7219_def(i,0,0);
    }

 void Clear_4_Matrice(void)
{  int i;
  for (i=0;i<8;i++)
   {
    SPI_Write_To_4x7219(i+1,0,0,0,0);
    Delay_us(20);
   }
  }
 


  void DS18B20_Build_value(unsigned int temp2write)
 {
 int jj;
 const unsigned int RES_SHIFT = TEMP_RESOLUTION - 8;
  unsigned char temp_whole;
  char Signe=0;
  unsigned int temp_fraction;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1  ;
      CRam1[0] = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Signe=0;
    CRam1[0] = ' ';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
  CRam1[1] = (temp_whole/10)%10 + 48;             // Extract tens digit
  if (CRam1[1]=='0')CRam1[1]=' ';
  CRam1[2] =  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
   CRam1[3]='.';
  // Convert temp_fraction to characters
  CRam1[4] =  temp_fraction/1000    + 48;         // Extract thousands digit
  CRam1[5] = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
  CRam1[6] =0;// (temp_fraction/10)%10  + 48;         // Extract tens digit
  CRam1[7]= 0; //temp_fraction%10      + 48;         // Extract ones digit
  CRam1[8]=0;
  Ltrim(CRam1+1);
 if (Signe==1)
  DS18B20_Temp1= ( temp_whole *1000) +temp_fraction  ;
  else
   DS18B20_Temp1= -(( temp_whole *1000) +temp_fraction  );
 }


void Arme_Timer1(int  Max_Timer1)
{
   // 100mS * Max_Timer1
//  T1CON         = 0x30;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
  Cpt1=  Max_Timer1;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IF_bit  = 0;
  TMR1IE_bit= 1;
  }


void Init_Timer1(void)
 {
// FOSC=64MHz
//Timer1
//Prescaler 1:8; TMR1 Preload = 15536; Actual Interrupt Time : 25 ms


  T1CON         = 0x31;
  T1RD16_bit=1;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
   TMR1IF_bit  = 0;
  TMR1IP_bit=1;   // high level interrupt
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}





void Wait_100mS(){  Delay_ms(100);}
void   Wait_250uS(void){ Delay_us(250); }



 void Raz_Buffer1()  // UART
{
      // nettoye le buffer
      for(Index1=0;Index1<MAXLEN_BUFFER1-1;Index1++)  Buffer1[Index1]=0;
      i1=0;
      Index1=0;
      c1=0;
      Flag_Buffer1 =0;
         RCSTA1.CREN=0 ;
        RCSTA1.CREN=1 ;
        PEIE_bit=1;
        c1=RC1REG;
        RC1IE_bit = 1 ;
      p1=0;
}


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
      Delay_us(5);
}

 void Init_Hardware()
{
  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;

  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  PORTC.B0=1;
  
  RTC_Forcee_Dir=1;   // PORTB.B1;
  HZ_Dir=1;           // RB0;
  Alarme_Melodie_Dir=0; // RB2;
  DOut_Dir=0;
  DOut=0;
 
   SPI_CS_Dir=0;
   SPI_CLOCK_Dir=0; // TRISC3_bit;
   SPI_DOUT_Dir=0; // TRISC5_bit;
   SPI_CS=1;
   SPI_DOUT=0;
   SPI_CLOCK =0;

  PORTA = 0b00111111;
  ANSELA=0;
  TRISA = 0b00101111 ;   // PORTA is RA0=1=OWS   RA1=1=analog input  RA2=input RA3,  RA4=Output RA5=input
  SQA_Dir=0;
  Led_Rouge_Dir=0; // RA4
  Led_Rouge=0;
  CCP5CON=0;
  
  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;


  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }


void Decompile_byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
   if ((un & masque)>0)
       UART1_Write('*');
     //  UART1_Write(49u);  //  '1'
    else
       UART1_Write(' ');
      // UART1_Write(48u);  //  '0'
    masque =masque >>1;
  }
}



 void Wait_Keyb(int T)
  {
    Raz_Buffer1() ;
    Arme_Timer1(T);
    UART1_Write_CText(" ... Waiting Keyboard Touch for <");
    IntToStr(T,CRam1);
    Ltrim(CRam1);     UART1_Write_Text(CRam1);
    UART1_Write_CText(" x 25mS >\r\n");
    while ( (Flag_Buffer1==0) && (Flag_Timer1==0));
    Flag_Timer1=0;
    Flag_Buffer1=0;
    CRLF1();
 }






void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 ndig += ie;
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}



unsigned char * Read_Msg_Eeprom( unsigned char debut)
{
 unsigned char Tampon[33];
 int i1;
 unsigned char Ce;
  i1=debut;
  do
  {
  Ce = EEPROM_Read(i1);
  if ( Ce==0) break;
  if ( i1>254) break;
  Tampon[i1-debut]=Ce;
  Delay_ms(5);
  i1++;
   }
  while (Ce!=0) ;
  Tampon[i1]=0;
  return Tampon;
 }

unsigned char Write_EEPROM(unsigned int addr, unsigned char length, unsigned char *source)       // not used !
{
  unsigned char *ptr;
  unsigned char loop;
  ptr = source;

EEADR = (unsigned char)(addr & 0x00FF);
  loop = length - 1;
  EECON1.EEPGD = 0;
  EECON1.CFGS  = 0;
  EECON1.WREN  = 1;
  do
  {
    //INTCONbits.GIEL = 0;
    EEDATA = *ptr;
    EECON2 = 0x55;
    EECON2 = 0xAA;
    EECON1.WR = 1;
    //INTCONbits.GIEL = 1;
    while(EECON1.WR == 1);
    ptr++;
    EEADR++;
  }while (loop--);
  EECON1.WREN  = 0;
  return 0;
}



 void ONES ()
 {
  _asm   {
      BSF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      BCF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      }
   }
  void ZEROS ()
  {
    _asm   {
      BSF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      BCF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      }
   }
   
   
void Init_Timer3()   // utilis en compteur interne
{
  // Fosc=64Mhz
 //Prescaler 1:8; TMR3 Preload = 5536; Actual Interrupt Time : 30 ms
 /*
  T3CON         = 0x31;
  TMR3IF_bit = 0;
  TMR3ON_bit=0;  // timer STOP !!!
  TMR3H         = 0x15;
  TMR3L         = 0xA0;
  TMR3IE_bit         = 0;  // no interrupt
 */
  T3CON         = 0x30;  // timer STOP !!!
  TMR3H         = 0x00;   //65535
  TMR3L         = 0x00;
  TMR3IF_bit    = 0;
  TMR3IE_bit    = 0;  // no interrupt
}



  void RAZ_Anneau_60_Leds()
 { int j;
   // RAZ pointeur led=0;
   DOut=0;
   Delay_us(300);
  // 60x 3 bytes RGB => 60 x 24=1440
  //----------------
   TMR3ON_bit=1;
   for (j=0;j<1440;j++)
   {
    // ZEROS();   // Byte =0 au format special protocole WS8121
     _asm   {
      BSF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      BCF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      }
   }
    TMR3ON_bit=0;

   // pointeur led=0;
   DOut=0;
   Delay_us(300);
   DOut=1;
  }
//==



void main()
{
  #ifdef FOSC_INTERNE
  // 1MHz par defaut
  // OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
  // OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
  OSCTUNE=0;
  OSCCON = 0b01110000  ; //0x72 ;     //Oscillateur  16Mhz *4
  OSCTUNE.PLLEN=1 ;   // =1 => FOSC x 4
  OSCCON2=0;
  //while (OSCCON.HFIOFS==0); // wait stable oscillator
  #else
  // Q=20Mhz
  #endif

  Init_Hardware() ;
  CCP5CON=0;
  LATCx=0;
  DOut=0;
  SPI_CS=1;
  
   RAZ_Anneau_60_Leds();

  Delay_ms(1000);
  Speed=100;
  Led_Rouge=0;
  for (i=0;i<MAXLEN2;i++) TEXTE[i]=0;
  txt=&TEXTE[0];

  UART1_Init(115200);
  Delay_ms(100);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  Delay_ms(100);
  CRLF1();
  

   if(Pre_TESTS==0)
   {
    UART1_Write_CText(" Entree Pre_TEST active (RA2=0)\r\n");
    UART1_Write_CText(" Test Cde DOut RC5 .. en ASM\r\n");
    for (i=0;i<6;i++)
    {
     _asm BSF _LATCx,5;
      UART1_Write('1'); Delay_1sec();
       _asm BCF _LATCx,5;
       UART1_Write('0'); Delay_1sec();
     CRLF1();
    }
    }

  // presentation sur UART1
  UART1_Write_CText (" Presentation : \r\n");
  for(i=0;i<9;i++)
  {
     UART1_Write_CText(Messages[i]);
   }
  Delay_ms(100);
  CRLF1();
  
  

  //-------------------------------
    UART1_Write_CText("Duree temp 50mS= ");
   Init_Timer3();
   TMR3ON_bit=1;
  Delay_ms(50);
   TMR3ON_bit=0;

   val3=TMR1L + (TMR3H<<8);
   if (TMR3IF_bit==1) val3=val3+65536;
    val3=val3>>1;  // count=0.5S
   LongWordToStr(val3,CRam1);
   UART1_Write_Text(CRam1);UART1_Write_CText("S\r\n");   //
  // Duree temp 10mS=      10072S
   CRLF1();


   // -------------------------------------

    UART1_Write_CText("Duree RAZ anneau= ");
   GIE_bit=0;
   Init_Timer3();
   // valeur initiale de Timer3
  // val1=TMR1L+ (TMR3H<<8);
   // armer ici Timer pour mesure duree globale de la fonction RAZ anneau
   //TMR3ON_bit=1;
   RAZ_Anneau_60_Leds();
   //TMR3ON_bit=0;

   val3=TMR1L + (TMR3H<<8);
   if (TMR3IF_bit==1) val3=val3+65536;
    val3=val3>>1;  // count=0.5S
   LongWordToStr(val3,CRam1);
   UART1_Write_Text(CRam1);UART1_Write_CText("S\r\n");   //
  //  Duree RAZ anneau=       3288S
   CRLF1();
   GIE_bit=1;

  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  //==========================================
  UART1_Write_CText(" Test Sonde OWS DS18B20\r\n");
   Wait_100mS();
   j=0;
   Ow_Reset(OWS_Pin_Sensor1);       // Onewire reset signal
   Wait_250uS();
   Ow_Write(OWS_Pin_Sensor1,0x33); // Read ROM (if only one device)
   Wait_250uS();
   c1=Ow_Read(OWS_Pin_Sensor1);
   Wait_250uS();
   UART1_Write_CText(" Family Code : ");
   *(CRam1)=0;
   ByteToHex(c1,CRam1);
   UART1_Write_Text(CRam1);
   UART1_Write_CText(" ID1= ");
   for (i=0;i<6;i++)
   {
       c1=  Ow_Read(OWS_Pin_Sensor1);
       Wait_250uS();
       ID1[i]=c1;
       *(CRam1)=0;
       ByteToHex(c1,CRam1);
       UART1_Write_Text(CRam1);
   }
   UART1_Write_CText("  CRC= ");
   c1=  Ow_Read(OWS_Pin_Sensor1); // CRC
   *(CRam1)=0;
   ByteToHex(c1,CRam1);
   UART1_Write_Text(CRam1);
   CRLF1();
   UART1_Write_CText(" Mesure DS18B20= ");
   Ow_Reset(OWS_Pin_Sensor1);         // Onewire reset signal
   Ow_Write(OWS_Pin_Sensor1,0xCC);   // Issue command SKIP_ROM
   Ow_Write(OWS_Pin_Sensor1,0x44);   // Issue command CONVERT_T
   Wait_250uS();
   Ow_Reset(OWS_Pin_Sensor1);
   Ow_Write(OWS_Pin_Sensor1,0xCC);   // Issue command SKIP_ROM
   Ow_Write(OWS_Pin_Sensor1,0xBE);   // Issue command READ_SCRATCHPAD  for only one sensor
   tempL = Ow_Read(OWS_Pin_Sensor1);
   temp = (Ow_Read(OWS_Pin_Sensor1) << 8) + tempL;
   DS18B20_Build_value(temp);
   Ltrim(CRam1);
   k=strlen(CRam1);
   strConstRamCpy(CRam1+k,"C  ");
   UART1_Write_Text(CRam1);  CRLF1();
   CRLF1();


  //=====================================================
  

  UART1_Write_CText(" Init RTC DS3231: \r\n");
  I2C1_Init(400000);

  
     UART1_Write_CText(" Active sortie SQW=1Hz: \r\n");
     write_DS3231(0x0E,0b01000000);    // batterie LIRC2032 4,4V

  if(RTC_Forcee==0)
  {
   UART1_Write_CText( "init valeurs RTC par defaut ");
   write_DS3231(0,0x50); //Reset second to 0 sec. and stop Oscillator
   write_DS3231(1,0x59); //write min
   write_DS3231(2,Dec2Bcd(14)); //write hour
   write_DS3231(3,0x02); //write day of week
   write_DS3231(4,0x01); // write date
   write_DS3231(5,0x05); // write month
   write_DS3231(6,Dec2Bcd(18)); // write year 2014
   }
   else
   {
       UART1_Write_CText(" Re-Lecture RTC ");
   }
   Display_Date_Time(1) ;
   CRLF1();
   
  // Test mesure de duree fonction avec Timer3
  /*
   CRLF1();
     UART1_Write_CText("mesure Delay_ms(59); r\n");
   Init_Timer3(); // 0.5S / count at 64MHz
   // valeur initial
   val1=(TMR3H<<8)|TMR1L;
   TMR3ON_bit=1;
   Delay_ms(59);
    TMR3ON_bit=0;
   val2=(TMR3H<<8)|TMR1L;
   if (TMR3IF_bit==1) val2=val2+65536;
   val3=val2-val1;
   val3=val3>>1;
   LongWordToStr(val3,CRam1);
   UART1_Write_Text(CRam1);UART1_Write_CText("S\r\n");
   CRLF1();
  */
   

   // arme interrupt RB0 pour detection changement d'etat des 8 entrees MCP23017

  UART1_Write_CText(" Init Interrupt RB0, synchro 1HzRTC \r\n");
  //INTEDG0_bit=0;  //IT on falling edge
  INTEDG0_bit=1;  //IT on rising edge
  Flag_RB0=0 ;
  INT0IF_bit=0;  // flag IT RB0
  INT0IE_bit=1;  // autorise IT RB0

   UART1_Write_CText(" Init Interrupt Timer1  & UART RX \r\n");
   IPEN_bit=1 ;
   IPR1.RC1IP=1;
   PIR1.RC1IE=1;
   RCSTA1.CREN=1;
   PEIE_bit = 1;          // Enable Peripheral interrupt
   GIE_bit  = 1;         // Enable Global interrupt
   k=0;
  //------------------------------------
    if(Pre_TESTS==0)
    {
        #include "Pre_Test_Anneau.inc"
    } // pretest 1

   UART1_Write_CText(" Test interrupt Timer1  20 x 100 msec soit 2sec \r\n" );

   Init_Timer1();
   Arme_Timer1(20);
   TXREG1='$';
   CRLF1();
   while(Flag_Timer1==0);
   TXREG1='#';
   CRLF1();
   k=0;

   Raz_Buffer1()  ;

   UART1_Write_CText("Bit Bang Soft SPI  RC2=Clk ,RC1=Dout  RC0=CS -> MAx7219:\r\n" )  ;
   //Soft_SPI_Init();

    SPI_CS=1;
   Init_4_Module_Max7219_8x8();


   UART1_Write_CText("Clear 4 Matrice \r\n" )  ;
   Clear_4_Matrice() ;
   CRLF1();
   SPI_CS=1;


  // pre tests  matrices ***********************
     if(Pre_TESTS==0)
   {
     #include "Pre_Test_Matrices.inc"
    }
    
    
   CRLF1();
   

    
    RAZ_Anneau_60_Leds();
    Raz_Buffer1();
    Delay_1sec();
    js=1;
    ms=0;
   do
   {
    // if(Sec<10)
    // SPI_Write_To_4x7219(REG_INTENSITY,    0x00,0x00,0x00,0x00); //intensit - intensity  minima
    // else
      // possibilit d'ajustementluminosit  F(soleil)
    // SPI_Write_To_4x7219(REG_INTENSITY,    0x01,0x01,0x01,0x01); //intensit - intensity  minima
     
     Display_Date_Time(1) ;   // param=1 => avec affichage sur terminal !
     Sec= Bcd2Dec(second);
     Mn= Bcd2Dec(minute);
     Hour= Bcd2Dec(heure);

    // lecture capteur OWS DS18B20
         UART1_Write(';') ;
         Ow_Reset(OWS_Pin_Sensor1);              // Onewire reset signal
         Ow_Write(OWS_Pin_Sensor1,0xCC);       // Issue command SKIP_ROM
         Ow_Write(OWS_Pin_Sensor1,0x44);       // Issue command CONVERT_T
         Wait_250uS();
         Ow_Reset(OWS_Pin_Sensor1);
         Ow_Write(OWS_Pin_Sensor1,0xCC);                   // Issue command SKIP_ROM
         Ow_Write(OWS_Pin_Sensor1,0xBE);                   // Issue command READ_SCRATCHPAD    for only one sensor
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
         tempL =  Ow_Read(OWS_Pin_Sensor1);
         temp = (Ow_Read(OWS_Pin_Sensor1) << 8) + tempL;
         DS18B20_Build_value(temp);
         Ltrim(CRam1);
         k=strlen(CRam1);
         strConstRamCpy(CRam1+k,"C  ");
         UART1_Write_Text(CRam1);
         CRLF1();

     //if((Mn%2==0)&& (Sec>5)&& (Sec<10))
     if(Sec & 0x04)
     {
       // en entree CRam1 a conserv la mesure de temperature au format 20.32C
       // il faut eliminer le '.' pour le remplacer par 2 point grafique  (Lettre_Point)
       // qui sera mix avec la 2em matrice unit de degr
       //  et recuperer le 1/10em de degr pour lemettre dans la 3em matrice
       // la 4em matrice recoit le caractere special C
       //CRam1[0]=*(time);
       //CRam1[1]=*(time+1);
       CRam1[2]= CRam1[3];
       CRam1[3]=127;
       CRam1[4]=0;
           Affiche_Text_Matrice(CRam1,1);
      }
      else
     {
      // format original Time : HH:MM:SS
      CRam1[0]=*(time);
      CRam1[1]=*(time+1);
      CRam1[2]=*(time+3);
      CRam1[3]=*(time+4);
      CRam1[4]=0;
          Affiche_Text_Matrice(CRam1,0);
     }

     
     
     


    // UART1_Write_CText(" Reset Index pointeur Led \r\n" );
    if (Sec==0)
       {
       UART1_Write_CText("\r\n RAZ anneau 60 leds  \r\n");
         RAZ_Anneau_60_Leds();     // 60x 3 bytes RGB => 60 x 24=1440
         DOut=0;
         Delay_ms(200);
      }
     js=0;
     ms=0;
     do
     {
        // effets visuels
        // couleur  GRB  code sur 24 groupes de 8 bits
         switch (ms)
         {
         case 0 :
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();   // Vert
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES() ;  // Rouge
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();   // Bleu
            break;
        case 1:
            //VERT
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES() ;
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            break;
         case 2:
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES() ; //BLEU
            break;
          case 3:
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES() ; //vert
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES() ; //rouge
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            break;
          case 4:
            ZEROS();ZEROS(); ZEROS();ZEROS();ONES() ;ZEROS();ZEROS();ZEROS();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES() ; //Rouge
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            break;
          case 5:
             // ROSE
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS(); //VERT
            ZEROS();ZEROS(); ONES() ;ONES() ;ONES() ;ONES() ;ONES() ;ONES() ; // ROUGE
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ONES() ;ONES() ;ONES() ; // BLEU
            break;

          default:
          // BLANC
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS(); ZEROS();ONES();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES();
            break ;
            
         }
         if (ms>4) ms=0;
       ms++;
       js++;
     } while(js<Sec+1);
      
      // synchro 1Hz RTC
       while(Flag_RB0==0);
       Flag_RB0=0 ;


   if (Flag_Buffer1==1) // c'est donc une Interrupt UART
   {
      p1=Buffer1;
    // for debugging only
    //UART1_Write_CText("\r\n Buffer1=");
     //k=strlen(Buffer1);
    // UART1_Write_Text(p1);
    // CRLF1();
    // --- analyse du buffer ------

     if((*(p1)=='H') && (*(p1+3)=='p'))     //Help<CR>
    {
       UART1_Write_CText("\r\n Help : Help<CR>  \r\n");
       UART1_Write_CText(" RTC Update: U;14;05;18;15;36;02#<CR>\r\n");
       UART1_Write_CText(" 14 Mai 2018 02(Lundi) 15H36\r\n");
       UART1_Write_CText(" Duree Melodie:DM=03<CR>gamme 2  20s\r\n");
       UART1_Write_CText(" Game Validation Melodie  GVM=08;21<CR>\r\n limites de 8H00  21H00\r\n");
       UART1_Write_CText(" OFFSET correction temperature LM35DZ \r\n OFS=-30 (limites -99  99)\r\n");

       CRLF1();
      p1=0;
     }
    if((*(p1)=='U') && (*(p1+20)=='#'))     //U;12;05;18;15;36;02;#<CR>
    {
       UART1_Write_CText("RTC Update : ");
       UART1_Write_Text(Buffer1);
       CRLF1();
       MAJ_RTC();
       Refresh_Date_Time() ;
       Sec= Bcd2Dec(second);
       Mn= Bcd2Dec(minute);
       Hour= Bcd2Dec(heure);
      p1=0;
    }

     if((*(p1)=='D') && (*(p1+1)=='M') &&(*(p1+2)=='=') && (strlen(Buffer1)<=6))  // DM=12<CR>
     {
       UART1_Write_Text(p1);
       *(p1+5)=0;
       k=atoi(p1+3);
       if ((k>1) && (k<21))
       {
         Duree_Melodie=k;
         for (i=0;i<2;i++)
          {  c1=*(p1+3+i);
             EEPROM_Write(0x6B+i, c1);
             Delay_ms(25);
             }
           c1=0;
          UART1_Write_CText("  OK = ");
          p2=Read_Msg_Eeprom(0x60) ;
           *(p2+15)=0;
          UART1_Write_Text(p2);
         }
         else
          UART1_Write_CText(" BAD ! ");
        CRLF1();
        p1=0;
      }
      if((*(p1)=='G') && (*(p1+1)=='V') && (*(p1+2)=='M') && (*(p1+3)=='=') && (strlen(Buffer1)>=8))  // GVM=07;22<CR>
      {

       UART1_Write_CText("Game Validation Melodie : ");
       UART1_Write_Text(p1);
        *(p1+6)=0;
        k=atoi(p1+4);
        *(p1+9)=0;
        *(p1+10)=0;
        m=atoi(p1+7);
       if ((m>12) && (m<24) && (k>=5) && (k<=12))
       {

         MinHour=k;
         for (i=0;i<2;i++)
          {  c1=*(p1+4+i);
             EEPROM_Write(0x7B+i, c1);
             Delay_ms(25);
             }
         MaxHour=m;
          for (i=0;i<2;i++)      // was <2
          {  c1=*(p1+7+i);
             EEPROM_Write(0x7E+i, c1);
             Delay_ms(25);
             }
         UART1_Write_CText(" Nouvel horaire Melodie : ");
          p2=Read_Msg_Eeprom(0x7A) ;
          UART1_Write_Text(p2);
         }
         else
            UART1_Write_CText(" BAD ! ");
        CRLF1();
        p1=0;
      }
      Raz_Buffer1();
    }
      // Wait_Keyb(20) ;
  } while(1);
 }




  /*


 Presentation :
 Mikroc 7.3.0 18F26K22
 Directory : C:_MikroC_MesProjets_MikroCC:Horloge_Anneau_60leds
 Projet : Horloge_4_Matrice8x8_Anneau_60leds_RGB.mcppi
 Source : Horloge_4_Matrice8x8_Anneau_60leds_RGB__190427.c
 1 Modules New 4 Matrices 8x8 avec MAX7129 CMS
 Terminal pourdailogue et Visu  deroulement programme
 Alim =3.6V_mini
 SPI WS2812 bit bang pour Anneau et SPI bit bang pour MAX7219
 Autres : Tiny_RTC_DS3231_for_AI2_1904.c

Duree temp 50mS=      50008S

Duree RAZ anneau=       2648S

 Test Sonde OWS DS18B20
 Family Code : 28 ID1= AA0D82381401  CRC= CD
 Mesure DS18B20= 20.62C

 Init RTC DS3231:
 Active sortie SQW=1Hz:
 Re-Lecture RTC 27-04-19  16:17:23
 Init Interrupt RB0, synchro 1HzRTC
 Init Interrupt Timer1  & UART RX
 Test interrupt Timer1  20 x 100 msec soit 2sec
$
#
Bit Bang Soft SPI  RC2=Clk ,RC1=Dout  RC0=CS -> MAx7219:
Clear 4 Matrice


27-04-19  16:17:24  ;20.56C
27-04-19  16:17:24  ;20.56C
27-04-19  16:17:25  ;20.56C
27-04-19  16:17:26  ;20.56C
27-04-19  16:17:27  ;20.56C
27-04-19  16:17:28  ;20.56C


0 1 mikroCPIC1618.exe -MSF -DBG -pP18F26K22 -RA -C -DL -O11111114 -fo64 -N"^C
C:\_MikroC\_MesProjets_MikroC\Horloge_Anneau_60leds\Horloge_4_Matrice8x8_Anneau_60leds_RGB.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\Horloge_Anneau_60leds\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\common\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"^C
C:\_MikroC\_MesProjets_MikroC\Horloge_Anneau_60leds\" "Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c" "Tiny_RTC_DS3231_for_AI2_1904.mcl" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_Conversions.mcl" "
_Lib_OneWire.mcl" "
_Lib_EEPROM_1024.mcl" "
_Lib_I2C_c34b12.mcl" "
_Lib_UART_c67b67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F26K22.c
2623 123 Compiled Successfully P18F26K22.c
0 122 Compilation Started
_Lib_Delays.c
172 123 Compiled Successfully
_Lib_Delays.c
0 122 Compilation Started tiny_rtc_ds3231_for_ai2_1904.h
80 1163 Variable 'cx' has been declared, but not used Tiny_RTC_DS3231_for_AI2_1904.c
80 1163 Variable 'mx' has been declared, but not used Tiny_RTC_DS3231_for_AI2_1904.c
80 1163 Variable 'hx' has been declared, but not used Tiny_RTC_DS3231_for_AI2_1904.c
194 123 Compiled Successfully Tiny_RTC_DS3231_for_AI2_1904.c
0 122 Compilation Started Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c
0 1004 interrupt handler (Interrupts at 0x0008) Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c
446 1163 Variable 'jj' has been declared, but not used Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c
1499 123 Compiled Successfully Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c
591 1164 Variable 'c1' has been eliminated by optimizer Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c
770 1164 Variable 'c1' has been eliminated by optimizer Horloge_4_Matrice8x8_Anneau_60leds_RGB_190427.c
0 127 All files Compiled in 609 ms
0 1144 Used RAM (bytes): 1703 (44%)  Free RAM (bytes): 2172 (56%) Used RAM (bytes): 1703 (44%)  Free RAM (bytes): 2172 (56%)
0 1144 Used ROM (bytes): 16908 (26%)  Free ROM (bytes): 48628 (74%) Used ROM (bytes): 16908 (26%)  Free ROM (bytes): 48628 (74%)
0 125 Project Linked Successfully Horloge_4_Matrice8x8_Anneau_60leds_RGB.mcppi
0 128 Linked in 250 ms
0 129 Project 'Horloge_4_Matrice8x8_Anneau_60leds_RGB.mcppi' completed: 1484 ms
0 103 Finished successfully: 27 avr. 2019, 15:41:49 Horloge_4_Matrice8x8_Anneau_60leds_RGB.mcppi



  */